# coding: utf-8

"""
    Trackside Software TeamDB API v2.0

    This API enables you to access TeamDB data  # noqa: E501

    OpenAPI spec version: 2.0
    Contact: support@trackside.fr
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class IssueProject(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'description': 'str',
        'issue_id_format': 'str',
        'workflow_id': 'str'
    }

    attribute_map = {
        'id': 'Id',
        'name': 'Name',
        'description': 'Description',
        'issue_id_format': 'IssueIdFormat',
        'workflow_id': 'WorkflowId'
    }

    def __init__(self, id=None, name=None, description=None, issue_id_format=None, workflow_id=None):  # noqa: E501
        """IssueProject - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._description = None
        self._issue_id_format = None
        self._workflow_id = None
        self.discriminator = None
        self.id = id
        self.name = name
        if description is not None:
            self.description = description
        self.issue_id_format = issue_id_format
        self.workflow_id = workflow_id

    @property
    def id(self):
        """Gets the id of this IssueProject.  # noqa: E501

        Unique identifier of the project  Set the Id to Guid.Empty (00000000-0000-0000-0000-000000000000) if you want to create a new project  # noqa: E501

        :return: The id of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IssueProject.

        Unique identifier of the project  Set the Id to Guid.Empty (00000000-0000-0000-0000-000000000000) if you want to create a new project  # noqa: E501

        :param id: The id of this IssueProject.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this IssueProject.  # noqa: E501

        Name of the project  # noqa: E501

        :return: The name of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IssueProject.

        Name of the project  # noqa: E501

        :param name: The name of this IssueProject.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this IssueProject.  # noqa: E501

        Description of the project  # noqa: E501

        :return: The description of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this IssueProject.

        Description of the project  # noqa: E501

        :param description: The description of this IssueProject.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def issue_id_format(self):
        """Gets the issue_id_format of this IssueProject.  # noqa: E501

        Project HumanId format  # noqa: E501

        :return: The issue_id_format of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._issue_id_format

    @issue_id_format.setter
    def issue_id_format(self, issue_id_format):
        """Sets the issue_id_format of this IssueProject.

        Project HumanId format  # noqa: E501

        :param issue_id_format: The issue_id_format of this IssueProject.  # noqa: E501
        :type: str
        """
        if issue_id_format is None:
            raise ValueError("Invalid value for `issue_id_format`, must not be `None`")  # noqa: E501

        self._issue_id_format = issue_id_format

    @property
    def workflow_id(self):
        """Gets the workflow_id of this IssueProject.  # noqa: E501

        Unique identifier of the associated workflow  # noqa: E501

        :return: The workflow_id of this IssueProject.  # noqa: E501
        :rtype: str
        """
        return self._workflow_id

    @workflow_id.setter
    def workflow_id(self, workflow_id):
        """Sets the workflow_id of this IssueProject.

        Unique identifier of the associated workflow  # noqa: E501

        :param workflow_id: The workflow_id of this IssueProject.  # noqa: E501
        :type: str
        """
        if workflow_id is None:
            raise ValueError("Invalid value for `workflow_id`, must not be `None`")  # noqa: E501

        self._workflow_id = workflow_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IssueProject, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IssueProject):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
